osg::Group Class Reference

`#include <Group>`

Inheritance diagram for osg::Group:

## Public Member Functions

| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

General group node which maintains a list of children. Children are reference counted. This allows children to be shared with memory management handled automatically via osg::Referenced.

## Constructor & Destructor Documentation

## Group() [1/2]

osg::Group::Group | ( |  | ) |

Referenced by asGroup(), asGroup(), osg::ClearNode::ClearNode(), Group(), osg::LightSource::LightSource(), and META_Node().

## Group() [2/2]

osg::Group::Group | ( | const Group & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Group(), and osg::CopyOp::SHALLOW_COPY.

## ~Group()

virtual osg::Group::~Group | ( |  | ) |

protected virtual

## Member Function Documentation

## addChild() [1/2]

template<class T>

bool osg::Group::addChild | ( | const ref_ptr< T > & | child | ) |

inline

References addChild(), and osg::ref_ptr< T >::get().

Referenced by addChild().

## addChild() [2/2]

virtual bool osg::Group::addChild | ( | Node * | child | ) |

virtual

Add Node to Group. If node is not NULL then increment its reference count, add it to the child list and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. Otherwise return false. Scene nodes can't be added as child nodes.

Reimplemented in osg::LOD, osg::PagedLOD, osg::ProxyNode, osg::Sequence, osg::Switch, and osgSim::MultiSwitch.

References osg::Node::Node().

Referenced by osg::LOD::traverse(), osg::PagedLOD::traverse(), osg::ProxyNode::traverse(), and osg::Sequence::traverse().

## asGroup() [1/2]

virtual Group * osg::Group::asGroup | ( |  | ) |

inline virtual

convert 'this' into a Group pointer if Node is a Group, otherwise return 0. Equivalent to dynamic_cast<Group*>(this).

Reimplemented from osg::Node.

References Group().

## asGroup() [2/2]

virtual const Group * osg::Group::asGroup | ( |  | ) | const

inline virtual

convert 'const this' into a const Group pointer if Node is a Group, otherwise return 0. Equivalent to dynamic_cast<const Group*>(this).

Reimplemented from osg::Node.

References Group().

## childInserted()

virtual void osg::Group::childInserted | ( | unsigned int |  | ) |

inline protected virtual

## childRemoved()

virtual void osg::Group::childRemoved | ( | unsigned int | ,
|  | unsigned int | )

inline protected virtual

## computeBound()

virtual BoundingSphere osg::Group::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Node.

Reimplemented in osg::Billboard, osg::ClipNode, osg::Geode, osg::LightSource, osg::LOD, osg::OccluderNode, osg::OcclusionQueryNode, osg::ProxyNode, osg::Switch, osg::Transform, osgGA::Widget, osgSim::Impostor, osgSim::SphereSegment, osgTerrain::TerrainTile, osgUI::Widget, and osgVolume::VolumeTile.

## containsNode() [1/2]

bool osg::Group::containsNode | ( | const Node * | node | ) | const

inline

Return true if node is contained within Group.

References _children, and osg::Node::Node().

## containsNode() [2/2]

template<class T>

bool osg::Group::containsNode | ( | const ref_ptr< T > & | node | ) | const

inline

References containsNode(), and osg::ref_ptr< T >::get().

Referenced by containsNode().

## getChild() [1/2]

Node * osg::Group::getChild | ( | unsigned int | i | ) |

inline

Return child node at position i.

References _children, and osg::Node::Node().

Referenced by osgWidget::Window::_geode(), and osgWidget::Window::_geode().

## getChild() [2/2]

const Node * osg::Group::getChild | ( | unsigned int | i | ) | const

inline

Return child node at position i.

References _children, and osg::Node::Node().

## getChildIndex()

unsigned int osg::Group::getChildIndex | ( | const Node * | node | ) | const

inline

Get the index number of child, return a value between 0 and _children.size()-1 if found, if not found then return _children.size().

References _children, and osg::Node::Node().

Referenced by osg::Geode::getDrawableIndex().

## getNumChildren()

virtual unsigned int osg::Group::getNumChildren | ( |  | ) | const

virtual

Return the number of children nodes.

Referenced by osg::Geode::getNumDrawables().

## insertChild() [1/2]

template<class T>

bool osg::Group::insertChild | ( | unsigned int | index,
|  | const ref_ptr< T > & | child )

inline

References osg::ref_ptr< T >::get(), and insertChild().

Referenced by insertChild().

## insertChild() [2/2]

virtual bool osg::Group::insertChild | ( | unsigned int | index,
|  | Node * | child )

virtual

Insert Node to Group at specific location. The new child node is inserted into the child list before the node at the specified index. No nodes are removed from the group with this operation.

Reimplemented in osg::Sequence, osg::Switch, and osgSim::MultiSwitch.

References osg::Node::Node().

Referenced by osg::Sequence::traverse().

## META_Node()

osg::Group::META_Node | ( | osg | ,
|  | Group | )

References Group().

## releaseGLObjects()

virtual void osg::Group::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objects for all graphics contexts.

Reimplemented from osg::Node.

Reimplemented in osg::Camera, osg::OcclusionQueryNode, osgFX::Effect, osgShadow::ShadowedScene, osgSim::OverlayNode, osgSim::SphereSegment, osgTerrain::TerrainTile, and osgUI::Widget.

## removeChild() [1/3]

template<class T>

bool osg::Group::removeChild | ( | const ref_ptr< T > & | child | ) |

inline

References osg::ref_ptr< T >::get(), and removeChild().

Referenced by removeChild().

## removeChild() [2/3]

virtual bool osg::Group::removeChild | ( | Node * | child | ) |

virtual

Remove Node from Group. If Node is contained in Group then remove it from the child list, decrement its reference count, and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. If Node is not found then return false and do not change the reference count of the Node. Note, do not override, only override removeChildren(,) is required.

Reimplemented in osg::Sequence, and osgSim::MultiSwitch.

References osg::Node::Node().

Referenced by osg::Sequence::traverse().

## removeChild() [3/3]

bool osg::Group::removeChild | ( | unsigned int | pos,
|  | unsigned int | numChildrenToRemove = 1 )

inline

Remove Node from Group. If Node is contained in Group then remove it from the child list, decrement its reference count, and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. If Node is not found then return false and do not change the reference count of the Node. Note, do not override, only override removeChildren(,) is required.

References _children, and removeChildren().

## removeChildren()

virtual bool osg::Group::removeChildren | ( | unsigned int | pos,
|  | unsigned int | numChildrenToRemove )

virtual

Remove children from Group. Note, must be override by subclasses of Group which add per child attributes.

Reimplemented in osg::LOD, osg::PagedLOD, osg::ProxyNode, osg::Sequence, and osg::Switch.

Referenced by removeChild().

## replaceChild() [1/2]

template<class T, class R>

bool osg::Group::replaceChild | ( | const ref_ptr< T > & | origChild,
|  | const ref_ptr< R > & | newChild )

inline

References osg::ref_ptr< T >::get(), and replaceChild().

Referenced by replaceChild().

## replaceChild() [2/2]

virtual bool osg::Group::replaceChild | ( | Node * | origChild,
|  | Node * | newChild )

virtual

Replace specified child Node with another Node. Equivalent to setChild(getChildIndex(orignChild),node) See docs for setChild for further details on implementation.

References osg::Node::Node().

## resizeGLObjectBuffers()

virtual void osg::Group::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Node.

Reimplemented in osg::Camera, osgFX::Effect, osgShadow::ShadowedScene, osgSim::OverlayNode, osgSim::SphereSegment, and osgUI::Widget.

## setChild()

virtual bool osg::Group::setChild | ( | unsigned int | i,
|  | Node * | node )

virtual

Set child node at position i. Return true if set correctly, false on failure (if node==NULL || i is out of range). When Set can be successful applied, the algorithm is : decrement the reference count origNode and increment the reference count of newNode, and dirty the bounding sphere to force it to recompute on next getBound() and return true. If origNode is not found then return false and do not add newNode. If newNode is NULL then return false and do not remove origNode. Also returns false if newChild is a Scene node.

References osg::Node::Node().

## setThreadSafeRefUnref()

virtual void osg::Group::setThreadSafeRefUnref | ( | bool | threadSafe | ) |

virtual

Set whether to use a mutex to ensure ref() and unref() are thread safe.

Reimplemented from osg::Node.

Reimplemented in osg::LightSource, osg::TexGenNode, and osgSim::OverlayNode.

## traverse()

virtual void osg::Group::traverse | ( | NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Node.

Reimplemented in osg::LOD, osg::PagedLOD, osg::ProxyNode, osg::Sequence, osg::Switch, osgFX::Effect, osgGA::Widget, osgManipulator::Dragger, osgPresentation::Cursor, osgPresentation::Timeout, osgShadow::ShadowedScene, osgSim::DOFTransform, osgSim::Impostor, osgSim::MultiSwitch, osgSim::OverlayNode, osgSim::SphereSegment, osgSim::VisibilityGroup, osgTerrain::Terrain, osgTerrain::TerrainTile, osgUI::Widget, osgVolume::Volume, osgVolume::VolumeScene, and osgVolume::VolumeTile.

## Member Data Documentation

## _children

NodeList osg::Group::_children

protected

Referenced by osg::Geode::containsDrawable(), containsNode(), getChild(), getChild(), getChildIndex(), osg::Geode::getDrawable(), osg::Geode::getDrawable(), and removeChild().

The documentation for this class was generated from the following file:

- Group